pro generate_VPP_netcdf_daily_main_realtime,year_in,jday_in,data_dir,arc_dir,out_dir

; modified by Chia Moeller 11-2022, from Rich's generate_APP_netcdf_daily_main_realtime.pro

   iyear = year_in
   ;iday = jday_in-2   ;;;; real julian day should be jday+1
   iday = jday_in-1    ;;;; for back processing Chia Moeller 12-2022
   ;iday = jday_in-1   ; for run_APP_PATMOSX_slurm.sh
   
   ;;;set the file name short header and version information
   short_name = 'Polar-VPP_v02r00_'
   ;short_name = 'Polar-APP_v01r01_'
   
   ;;;read in the longitude/latitude of the 5 km EASE-Grid
   lat_filenames = ['/home/chial/IDL/Na5.latt.1805x1805x1.float','/home/chial/IDL/Sa5.latt.1605x1605x1.float']
   lon_filenames = ['/home/chial/IDL/Na5.lonn.1805x1805x1.float','/home/chial/IDL/Sa5.lonn.1605x1605x1.float']      
   dimxyN = 1805
   ; add the longitude
   lonn_n = fltarr(dimxyN,dimxyN)
   openr,ur,lon_filenames(0),/get_lun
   readu,ur,lonn_n
   free_lun,ur  
   ; add the latitude
   latt_n = fltarr(dimxyN,dimxyN)
   openr,ur,lat_filenames(0),/get_lun
   readu,ur,latt_n
   free_lun,ur
   dimxyN = 1605
   ; add the longitude
   lonn_s = fltarr(dimxyN,dimxyN)
   openr,ur,lon_filenames(1),/get_lun
   readu,ur,lonn_s
   free_lun,ur  
   ; add the latitude
   latt_s = fltarr(dimxyN,dimxyN)
   openr,ur,lat_filenames(1),/get_lun
   readu,ur,latt_s
   free_lun,ur

   sspole = 0
   ssslt = 0
   ssday = 0

   poles = ['Arctic','Antarctic']
   slt1  = ['0400','1400']
   slt2  = ['0200','1400']
   
   ;;; input directory of VPP data, and output directory of NetCDF files   
   
   ; summary_text = ''
   ; openr,ur,'/home/rdworak/APP/lib/summary',/get_lun
   ; readf,ur,summary_text
   ; free_lun,ur
   
   print,'processing Year: ',iyear
      
   viirs_sensor = 'VIIRS'       
   if iyear ge 2001 then viirs_sensor = 'VIIRS'
        
   if iyear mod 4 eq 0 then tdays = 366 else tdays = 365
      
   ;get_platform,iyear,avhrr_platform
      
   print,'day: ',iday+1
   juldate = julday(1,1,iyear)+iday
   caldat,juldate,month,mday,myear	
	 
   for ipole=sspole,n_elements(poles)-1 do begin
     if ipole eq 0 then slts = slt1 else slts = slt2
     
     if ipole eq 0 then begin
        pole = 'Arctic' 
        dimxyN = 1805
        arr_lat_min = '48.4'
        arr_lat_max = '90.0'
        arr_lon_min = '-180.0'
        arr_lon_max = '180.0'
        ;lon_filename = 'Na5.lonn.1805x1805x1.float'
        ;lat_filename = 'Na5.latt.1805x1805x1.float'
        latitude_range=[48.0,90.0] 
	pole_str='n' 
	lonn = lonn_n
	latt = latt_n
	latitude_of_projection_origin = 90.         
     endif else begin  
        pole='Antarctic'
        dimxyN = 1605
        arr_lat_min = '-90.0'
        arr_lat_max = '-53.2'
        arr_lon_min = '-180.0'
        arr_lon_max = '180.0'
        ;lon_filename = 'Sa5.lonn.1605x1605x1.float'
        ;lat_filename = 'Sa5.latt.1605x1605x1.float'
        latitude_range=[-90.0,-53.0]            
	pole_str='s'
	lonn = lonn_s
	latt = latt_s
	latitude_of_projection_origin = -90.         
     endelse   

     for islt = ssslt, n_elements(slts)-1 do begin
	 
       slt = slts(islt)
	    				    
       ;;;; determine the creation time of the VPP;;;;;;;;;;;;;;;;;;;;;;
       ;syst = systime(/julian,/utc)
       ;caldat,syst,zmonth,zday,zyear,zhour,zminute,zsecond
       ;create_time = string(zyear,format='(i4)')+'-'+string(zmonth,format='(i02)')+'-'+string(zday,format='(i02)')+'T'+string(zhour,format='(i02)')+':'+ $
       ;              string(zminute,format='(i02)')+':'+string(fix(zsecond),format='(i02)')+'Z'
       ;app_filename = data_dir + poles(ipole)+'/'+string(iyear,format='(i4)')+'/'+'app_'+pole_str+'005_'+string(iyear,format='(i4)')+string(iday+1,format='(i03)')+'_'+slt+'.img.gz'               
       ;if iyear eq 2014 then app_filename = data_dir + poles(ipole)+'/unnorm/'+string(iyear,format='(i4)')+'/'+'app_'+pole_str+'005_'+string(iyear,format='(i4)')+string(iday+1,format='(i03)')+'_'+slt+'.img.gz' 
	       
       vpp_filename = data_dir +'vpp_'+pole_str+'005_'+string(iyear,format='(i4)')+string(iday+1,format='(i03)')+'_'+slt+'.img.gz'
	      
       print,'vpp_filename1: ',vpp_filename 
       file_res = file_info(vpp_filename)  ;;; file_res.atime(ctime,mtime): date of last access, of file status change, and of last modification given in seconds since 1/1/1970 UTC
                          
       a_julday=julday(1,1,1970)-1.+file_res.mtime/(3600.*24.)
       caldat,a_julday,c_month,c_day,c_year
       create_time_s = 'c'+string(c_year,format='(i4)')+string(c_month,format='(i02)')+string(c_day,format='(i02)')
       create_time = string(c_year,format='(i4)')+'-'+string(c_month,format='(i02)')+'-'+string(c_day,format='(i02)')
	       
       print,'create_time_s, create_time'
       print,create_time_s,create_time   
	       
       ;;;;----------------------------- file names------------------------------------------------
       netCDF_filename1 = short_name+strupcase(pole_str)+'hem_'+slt+'_d'+string(iyear,format='(i4)')+string(month,format='(i02)')+string(mday,format='(i02)')+'_'+create_time_s+'.nc'
       netCDF_filename = netCDF_filename1 
	       
       tar_filename = short_name+'d'+string(iyear,format='(i4)')+string(month,format='(i02)')+string(mday,format='(i02)')+'_'+create_time_s+'.tar.gz'
       mnf_filename = tar_filename+'.mnf'
       ;;;;----------------------------- file names------------------------------------------------
	       
       ;Create a new netCDF file
       clobber = 1
       id = NCDF_CREATE(netCDF_filename,clobber=clobber,/NETCDF4_FORMAT)
   
       ; Fill the file with defult values
       NCDF_CONTROL,id,/FILL
   
       arr_summary  = 'NOAA VIIRS Polar Pathfinder Fundamental Climate Data Rcord; calibrated reflectance and brightness temperature in Year '+string(iyear,format='(i4)')
       arr_keywords = 'EARTH SCIENCE > SPECTRAL/ENGINEERING > INFRARED WAVELENGTHS > BRIGHTNESS TEMPERATURE, '+ $  
                  'EARTH SCIENCE > SPECTRAL/ENGINEERING > VISIBLE WAVELENGTHS > VISIBLE IMAGERY'
       arr_key_vol  = 'NASA Global Change Master Directory (GCMD) Earth Science Keywords, Version 8'
       ;arr_cdr_vars = 'fcdr_reflectance_0.6um, fcdr_reflectance_0.8um, fcdr_brightness_temperature_3.7um, fcdr_brightness_temperature_11um,fcdr_brightness_temperature_12um, '+$
       ;   'Sensor Scanning Angle, Solar Zenith Angle, Sensor Relative Azimuth Angle, GMT of observation'
       arr_cdr_vars = 'fcdr_reflectance_0.6um, fcdr_reflectance_0.8um, fcdr_brightness_temperature_3.7um, fcdr_brightness_temperature_11um,fcdr_brightness_temperature_12um' 
       arr_inst     = 'Cooperative Institute for Meteorological Studies, University of Wisconsin at Madison'
	       
       ;syst = systime(/julian,/utc)
       ;caldat,syst,zmonth,zday,zyear,zhour,zminute,zsecond
       ;create_time = string(zyear,format='(i4)')+'-'+string(zmonth,format='(i02)')+'-'+string(zday,format='(i02)')+'T'+string(zhour,format='(i02)')+':'+ $
       ;              string(zminute,format='(i02)')+':'+string(fix(zsecond),format='(i02)')+'Z'
               
       zslt = 0  & reads,slt,zslt & zslt=zslt/100
       print,'iday,hour: ',iday,zslt		       	
       current_time = julday(1,1,iyear,zslt)+iday
	       
       ;;;;;
       ;time_value = julday(1,1,iyear,zslt) - julday(1,1,iyear)
       time_value= julday(1,1,iyear)+iday-julday(1,1,iyear)+double(zslt)/24
       ;;;;;
	       
       start_time = current_time-double(3.+12.)/24.
       caldat,start_time,zmonth,zday,zyear,zhour,zminute,zsecond
       print,zmonth,zday,zyear,zhour,zminute,zsecond
       coverage_start = string(zyear,format='(i4)')+'-'+string(zmonth,format='(i02)')+'-'+string(zday,format='(i02)')+'T'+string(zhour,format='(i02)')+':'+ $
                        string(zminute,format='(i02)')+':'+string(fix(zsecond),format='(i02)')+'Z'
       end_time   = current_time+double(3.+12.)/24.		     
       caldat,end_time,zmonth,zday,zyear,zhour,zminute,zsecond
       print,zmonth,zday,zyear,zhour,zminute,zsecond
       coverage_end = string(zyear,format='(i4)')+'-'+string(zmonth,format='(i02)')+'-'+string(zday,format='(i02)')+'T'+string(zhour,format='(i02)')+':'+ $
                      string(zminute,format='(i02)')+':'+string(fix(zsecond),format='(i02)')+'Z'	       		       		     

       att_GLOBAL = {                                                                                                  $
                     conventions               : 'CF-1.6, Unidata Dataset Discovery v1.0, NOAA CDR v1.0, GDS v2.0',    $
                     standard_name_vocabulary  : 'CF Standard Name Table (v26, 08 November 2013)',                     $
                     id                        : netcdf_filename1,                                                     $
                     nameing_authority         : 'gov.noaa.ncdc',                                                      $
                     metadata_link             : 'DOI',                                                                $
                     title                     : 'VIIRS Polar Pathfinder Fundamental Climate Data Record',             $
                     product_version           : 'v2.0',                                                               $
                     keywords                  : arr_keywords,                                                         $
                     keywords_vocabulary       : arr_key_vol,                                                          $
                     sensor                    : viirs_sensor,                                                         $
                     cdm_data_type             : 'Grid',                                                               $
                     cdr_program               : 'NOAA Climate Data Record Program for satellites',                    $
                     cdr_variable              : arr_cdr_vars,                                                         $
                     references                : 'http://snpp.umd.edu/VGAC/',                                          $
                     source                    : 'composition of calibrated VIIRS GAC Level 1b data',                  $
                     date_created              : create_time,                                                          $
                     institution               : arr_inst,                                                             $
                     geospatial_lat_min        : arr_lat_min,                                                          $
                     geospatial_lat_max        : arr_lat_max,                                                          $
                     geospatial_lon_min        : arr_lon_min,                                                          $
                     geospatial_lon_max        : arr_lon_max,                                                          $
                     geospatial_lat_units      : 'degrees_north' ,                                                     $
                     geospatial_lon_units      : 'degrees_east',                                                       $
                     spatial_resolution        : '5 km',                                                               $
                     time_coverage_start       : coverage_start,                                                       $
                     time_coverage_end         : coverage_end,                                                         $
                     license                   : 'No restrictions on access or use'                                    $
                    }
       
       ; Set the Global attribute
       tagnum   = N_TAGS(att_GLOBAL)
       tagnames = TAG_NAMES(att_GLOBAL)
       if tagnum gt 0 then begin
         for ic = 0, tagnum-1 do begin
	    ;print,tagnames(ic),att_GLOBAL.(ic)
            if ic eq 0 then begin
              NCDF_ATTPUT,id,/GLOBAL,'Conventions',att_GLOBAL.(ic)
            endif else begin
              NCDF_ATTPUT,id,/GLOBAL,strlowcase(tagnames(ic)),att_GLOBAL.(ic)
            endelse	
         endfor
       endif
   
       ; Define the dimensions
       xid = NCDF_DIMDEF(id,'rows',dimxyN)
       yid = NCDF_DIMDEF(id,'columns',dimxyN)
       zid = NCDF_DIMDEF(id,'Time',/UNLIMITED)
   
       ; Define variable
   
       lonid = NCDF_VARDEF(id,'longitude',[xid,yid],/FLOAT)
       NCDF_ATTPUT,id,lonid,'standard_name','longitude'
       NCDF_ATTPUT,id,lonid,'long_name','longitude of EASE Grid 5km resolution in the polar regions, Arctic (1805, 1805), Antarctic (1605, 1605)'  
       ;NCDF_ATTPUT,id,lonid,'valid_range',[-180.0,180.0]  
       NCDF_ATTPUT,id,lonid,'units','degrees_east'  

       latid = NCDF_VARDEF(id,'latitude',[xid,yid],/FLOAT)
       NCDF_ATTPUT,id,latid,'standard_name','latitude'
       NCDF_ATTPUT,id,latid,'long_name','latitude of EASE Grid 5km resolution in the polar regions, Arctic (1805, 1805), Antarctic (1605, 1605)'  
       ;NCDF_ATTPUT,id,latid,'valid_range',latitude_range  
       NCDF_ATTPUT,id,latid,'units','degrees_north'  

       dayid = NCDF_VARDEF(id,'time',[zid],/DOUBLE )
       NCDF_ATTPUT,id,dayid,'standard_name','time'
       NCDF_ATTPUT,id,dayid,'long_name', 'days since '+string(iyear,format='(i4)')+'-01-01 00:00:00'
       NCDF_ATTPUT,id,dayid,'units','days since '+string(iyear,format='(i4)')+'-01-01 00:00:00 0:00'  
       NCDF_ATTPUT,id,dayid,'axis','T'  
       
       ;;;;change on 08/20/2015;;;;;  how to set this variable as scalar?
       coordid =  NCDF_VARDEF(id,'crs',/float)
       NCDF_ATTPUT,id,coordid,'comment','Data is stored in 5 km EASE-Grid. Refer to the link in the references'
       NCDF_ATTPUT,id,coordid,'grid_mapping_name','lambert_azimuthal_equal_area'
       NCDF_ATTPUT,id,coordid,'longitude_of_projection_origin',0.0
       NCDF_ATTPUT,id,coordid,'latitude_of_projection_origin',latitude_of_projection_origin
       NCDF_ATTPUT,id,coordid,'false_easting',0.0	       
       NCDF_ATTPUT,id,coordid,'false_northing',0.0
       NCDF_ATTPUT,id,coordid,'earth_radius',6371228.0
       ;NCDF_ATTPUT,id,coordid,'_ChunkSizes',1,/SHORT
       ;;;;change on 08/20/2015
	       
       Ch1id = NCDF_VARDEF(id,'fcdr_reflectance_ch1',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Ch1id,'standard_name','ch1_toa_bidirectional_reflectance'
       NCDF_ATTPUT,id,Ch1id,'long_name','VIIRS band I1 reflectance (0.58 um to 0.68 um)'
       ;NCDF_ATTPUT,id,Ch1id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Ch1id,'scale_factor', 0.001 
       NCDF_ATTPUT,id,Ch1id,'valid_range',[0,1000]  
       NCDF_ATTPUT,id,Ch1id,'_FillValue', -9999          ;;;default filling value
       ;NCDF_ATTPUT,id,Ch1id,'missing_value',9999         ;;;missing value
       NCDF_ATTPUT,id,Ch1id,'units','1'
       NCDF_ATTPUT,id,Ch1id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Ch1id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Ch1id,'coverage_content_type','physicalMeasurement'

       Ch2id = NCDF_VARDEF(id,'fcdr_reflectance_ch2',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Ch2id,'standard_name','ch2_toa_bidirectional_reflectance'
       NCDF_ATTPUT,id,Ch2id,'long_name','VIIRS band I2 reflectance (0.725 um to 1.0 um)'
       ;NCDF_ATTPUT,id,Ch2id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Ch2id,'scale_factor', 0.001 
       NCDF_ATTPUT,id,Ch2id,'valid_range',[0,1000]  
       NCDF_ATTPUT,id,Ch2id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Ch2id,'missing_value',9999  
       NCDF_ATTPUT,id,Ch2id,'units','1'
       NCDF_ATTPUT,id,Ch2id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Ch2id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Ch2id,'coverage_content_type','physicalMeasurement'
	       
       ;;;; 5/1/2003 16:05:00  NOAA 16 switch to channel 3B only, inhibit automatic 3A-B switching
       ;;;; 8/5/2005 14:01:00  Disable automatic channel 3A/3B swith
       ;;;; NOAA18 is available from Jan 1, 2005, however
       ;;;; NOAA16 data is included till jday 221, 2005, then NOAA 18 is included
	   
       ;if iyear lt 2001 then begin
       Ch3id = NCDF_VARDEF(id,'fcdr_brightness_temperature_ch3',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Ch3id,'standard_name','ch3_brightness_temperature'
       NCDF_ATTPUT,id,Ch3id,'long_name','VIIRS band M12 brightness temperature (3.55 um to 3.93 um)'   
       NCDF_ATTPUT,id,Ch3id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Ch3id,'valid_range',[1900,4000]  
       NCDF_ATTPUT,id,Ch3id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Ch3id,'missing_value',9999  
       NCDF_ATTPUT,id,Ch3id,'units','K'
       NCDF_ATTPUT,id,Ch3id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Ch3id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Ch3id,'coverage_content_type','physicalMeasurement'
   
       Ch4id = NCDF_VARDEF(id,'fcdr_brightness_temperature_ch4',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Ch4id,'standard_name','ch4_brightness_temperature'
       NCDF_ATTPUT,id,Ch4id,'long_name','VIIRS band M15 brightness temperature (10.3 um to 11.3 um)'   
       NCDF_ATTPUT,id,Ch4id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Ch4id,'valid_range',[1900,4000]  
       NCDF_ATTPUT,id,Ch4id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Ch4id,'missing_value',9999  
       NCDF_ATTPUT,id,Ch4id,'units','K'
       NCDF_ATTPUT,id,Ch4id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Ch4id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Ch4id,'coverage_content_type','physicalMeasurement'

       Ch5id = NCDF_VARDEF(id,'fcdr_brightness_temperature_ch5',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Ch5id,'standard_name','ch5_brightness_temperature'
       NCDF_ATTPUT,id,Ch5id,'long_name','VIIRS band M16 brightness temperature (11.5 um to 12.5 um)'   
       NCDF_ATTPUT,id,Ch5id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Ch5id,'valid_range',[1900,4000]  
       NCDF_ATTPUT,id,Ch5id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Ch5id,'missing_value',9999  
       NCDF_ATTPUT,id,Ch5id,'units','K'
       NCDF_ATTPUT,id,Ch5id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Ch5id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Ch5id,'coverage_content_type','physicalMeasurement'

       Par6id = NCDF_VARDEF(id,'scan',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Par6id,'standard_name','satellite_scan_angle'
       NCDF_ATTPUT,id,Par6id,'long_name','Satellitel Scan Angle'
       NCDF_ATTPUT,id,Par6id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Par6id,'valid_range',[0,900]  
       NCDF_ATTPUT,id,Par6id,'_FillValue', -9999 
       NCDF_ATTPUT,id,Par6id,'units','degree'
       NCDF_ATTPUT,id,Par6id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Par6id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Par6id,'coverage_content_type','referenceInfromation'

       Par7id = NCDF_VARDEF(id,'szaa',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Par7id,'standard_name','solar_zenith_angle'
       NCDF_ATTPUT,id,Par7id,'long_name','Solar Zenith Angle'
       NCDF_ATTPUT,id,Par7id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Par7id,'valid_range',[0,1800]  
       NCDF_ATTPUT,id,Par7id,'_FillValue', -9999 
       NCDF_ATTPUT,id,Par7id,'units','degree'
       NCDF_ATTPUT,id,Par7id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Par7id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Par7id,'coverage_content_type','referenceInformation'

       Par8id = NCDF_VARDEF(id,'relaz',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Par8id,'standard_name','Sun-Satellite_relative_azimuth_angle'
       NCDF_ATTPUT,id,Par8id,'long_name','Sun-Satellite Relative Azimuth Angle'   
       NCDF_ATTPUT,id,Par8id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Par8id,'valid_range',[0,1800]  
       NCDF_ATTPUT,id,Par8id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Par8id,'missing_value',9999  
       NCDF_ATTPUT,id,Par8id,'units','degree'
       NCDF_ATTPUT,id,Par8id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Par8id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Par8id,'coverage_content_type','referenceInformation'

       Par9id = NCDF_VARDEF(id,'gmt',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Par9id,'standard_name','greenwich_mean_time'
       NCDF_ATTPUT,id,Par9id,'long_name','greenwich mean time of the observation in the format of hour*1000 + minute*100 + second/10'   
       NCDF_ATTPUT,id,Par9id,'scale_factor', 0.1 
       NCDF_ATTPUT,id,Par9id,'valid_range',[0,240]  
       NCDF_ATTPUT,id,Par9id,'_FillValue', -9999 
       ;NCDF_ATTPUT,id,Par9id,'missing_value',9999  
       NCDF_ATTPUT,id,Par9id,'units','hours'
       NCDF_ATTPUT,id,Par9id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Par9id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Par9id,'coverage_content_type','referenceInformation'

       Par10id = NCDF_VARDEF(id,'sfctype',[xid,yid,zid],/SHORT)
       NCDF_ATTPUT,id,Par10id,'standard_name','surface_type'
       NCDF_ATTPUT,id,Par10id,'long_name','surface type of each pixel of EASE Grid 5 km '   
       NCDF_ATTPUT,id,Par10id,'valid_range',[0,255]  
       NCDF_ATTPUT,id,Par10id,'_FillValue', -9999  ;;; with this line, the netcdf file with z dimention always as 0
       NCDF_ATTPUT,id,Par10id,'flag_values',[0,1,100,101,102,103,252,253,254,255]
       NCDF_ATTPUT,id,Par10id,'flag_meanings','snow_free_land sea_ice_concentration_1_percent sea_ice_concentration_100_percent permanent_ice not_used snow mixed_pixels_at_coastlines suspect_ice_value corners ocean'
       NCDF_ATTPUT,id,Par10id,'grid_mapping','crs'
       NCDF_ATTPUT,id,Par10id,'coordinates','longitude latitude time'
       NCDF_ATTPUT,id,Par10id,'coverage_content_type','auxilliaryData'

       ;put file in data mode
       NCDF_CONTROL,id,/ENDEF

       ; add the longitude  
       NCDF_VARPUT,id,lonid,lonn
  
       ; add the latitude
       NCDF_VARPUT,id,latid,latt
	    
       vpp_filename = data_dir +'vpp_'+pole_str+'005_'+string(iyear,format='(i4)')+string(iday+1,format='(i03)')+'_'+slt+'.img.gz'
       sfc_filename = arc_dir +'vpp_'+pole_str+'005_'+string(iyear,format='(i4)')+string(iday+1,format='(i03)')+'_smsk.img.gz'
	       
       print,'vpp_filename2: ',vpp_filename	       

       res = file_info(vpp_filename)
       ;;;labels = ['ch1','ch2','ch3','ch4','ch5','Scan angle','Solar zenith angle','satellite relative azimuth angle','time']
                  
       nfields = 9   
       img = intarr(dimxyN,dimxyN,nfields)	       
       if res.exists eq 1 then begin
	 compress = 1
         openr,ur,vpp_filename,/get_lun,compress=compress
         readu,ur,img
         free_lun,ur
       endif
	       
       sfc = bytarr(dimxyN,dimxyN)
       res = file_info(sfc_filename)
       if res.exists eq 1 then begin	       
	 compress = 1
  	 openr,ur,sfc_filename,/get_lun,compress=compress
   	 readu,ur,sfc
 	 free_lun,ur
       endif
       sfc = fix(sfc)

;         temp_img = reform(img(*,*,3))
;         xxx = where(temp_img eq 0., cxx)
;         if cxx gt 0 then begin
;           for icz=0,nfields-1 do begin
;             t_img = reform(img(*,*,icz))
;             t_img(xxx) = -9999
;             img(*,*,icz) = t_img
;           endfor
;           sfc(xxx) = -9999
;         endif

;!   the for loops are added for quality control. Chia Moeller 2-2023
;    ch1 and ch2 will have scale factor 0.0001
;    ch3, ch4, and ch4 will have scale factor 0.1
      for img_id=0,1 do begin

        temp_img = reform(img(*,*,img_id))
        xxx = where(temp_img gt 1000. or temp_img le 0., cxx)
        if cxx gt 0 then begin
         for icz=0,nfields-1 do begin
             t_img = reform(img(*,*,icz))
             t_img(xxx) = -9999
            img(*,*,icz) = t_img
          endfor
           sfc(xxx) = -9999
        endif

       endfor

       for img_id=2,3,4 do begin

        temp_img = reform(img(*,*,img_id))
        xxx = where(temp_img gt 4000. or temp_img lt 1000., cxx)
;        xxx = where(temp_img eq 0., cxx)
        if cxx gt 0 then begin
 	 for icz=0,nfields-1 do begin
             t_img = reform(img(*,*,icz))
             t_img(xxx) = -9999
 	    img(*,*,icz) = t_img
 	  endfor
           sfc(xxx) = -9999
        endif

       endfor
;!   the for loops are added for quality control. Chia Moeller 2-2023
	       	       
       offset_jday = [0,0,0]
       ;NCDF_VARPUT,id,dayid,iday+1,offset=[iday]
       ;NCDF_VARPUT,id,dayid,iday+1,offset=[0]
       NCDF_VARPUT,id,dayid,time_value
       NCDF_VARPUT,id,Ch1id,reform(img(*,*,0)),OFFSET=offset_jday  
       NCDF_VARPUT,id,Ch2id,reform(img(*,*,1)),OFFSET=offset_jday
       NCDF_VARPUT,id,Ch3id,reform(img(*,*,2)),OFFSET=offset_jday
       NCDF_VARPUT,id,Ch4id,reform(img(*,*,3)),OFFSET=offset_jday
       NCDF_VARPUT,id,Ch5id,reform(img(*,*,4)),OFFSET=offset_jday
       NCDF_VARPUT,id,Par6id,reform(img(*,*,5)),OFFSET=offset_jday
       NCDF_VARPUT,id,Par7id,reform(img(*,*,6)),OFFSET=offset_jday
       NCDF_VARPUT,id,Par8id,reform(img(*,*,7)),OFFSET=offset_jday
       NCDF_VARPUT,id,Par9id,reform(img(*,*,8)),OFFSET=offset_jday	       	       
       NCDF_VARPUT,id,Par10id,sfc,OFFSET=offset_jday
	       
       ; close the NetCDF file
       NCDF_CLOSE,id
     endfor   ;;; solar local time
	    
   endfor   ;;; pole arctic, antarctic
      
   print,'compressing ...'
   print,'tar_filename ', tar_filename
   compress_command = 'tar zcvf '+tar_filename+' *.nc'
   spawn,compress_command
   mnf_command = 'md5sum '+tar_filename+' | cut -d " " -f1'
   spawn,mnf_command,mnf
   size_command='ls -al '+tar_filename+' | cut -d " " -f6'
   spawn,size_command,msize      
   spawn,'echo '+tar_filename+','+mnf+','+msize+'> '+mnf_filename
      
   ;spawn,'scp '+tar_filename+' stratus:/data/ftp/pub/yinghuil/NCDC/real_time/APP'
   ;spawn,'scp '+mnf_filename+' stratus:/data/ftp/pub/yinghuil/NCDC/real_time/APP'
   ;spawn,'mv '+tar_filename+' '+out_dir
   ;spawn,'mv '+mnf_filename+' '+out_dir
   ;spawn,'rm *.nc'
      
end
