   ;-------------------------------------------------------------------------------------- 
   ;mreadf.pro   2015-08-14  Yinghui Liu
   ;-------------------------------------------------------------------------------------- 
   ; AVHRR Polar Pathfinder (APP) PROCESSING SOFTWARE Version 1.1
   ; NAME: mreadf.pro
   ; PURPOSE: subroutine to extract, and calibrate AVHRR GAC data
   ; DESCRIPTION: subroutine to calibrate AVHRR Global Area Coverage (GAC).
   ;              The calibration approach is developed by Andy Heidinger (Andrew.Heidinger@noaa.gov). 
   ;              It was in Fortran language, and converted to IDL language by the authors. 
   ;
   ; AUTHORS:
   ;  Yinghui Liu, yinghuil@ssec.wisc.edu
   ;  Richard Dworak, rdworak@ssec.wisc.edu
   ;  Jeffrey Key, jeff.key@noaa.gov
 
   ; COPYRIGHT  
   ; THIS SOFTWARE AND ITS DOCUMENTATION ARE CONSIDERED TO BE IN THE PUBLIC
   ; DOMAIN AND THUS ARE AVAILABLE FOR UNRESTRICTED PUBLIC USE. THEY ARE
   ; FURNISHED "AS IS." THE AUTHORS, THE UNITED STATES GOVERNMENT, ITS
   ; INSTRUMENTALITIES, OFFICERS, EMPLOYEES, AND AGENTS MAKE NO WARRANTY,
   ; EXPRESS OR IMPLIED, AS TO THE USEFULNESS OF THE SOFTWARE AND
   ; DOCUMENTATION FOR ANY PURPOSE. THEY ASSUME NO RESPONSIBILITY (1) FOR
   ; THE USE OF THE SOFTWARE AND DOCUMENTATION; OR (2) TO PROVIDE TECHNICAL
   ; SUPPORT TO USERS.
   
   ; Software required
   ; IDL: Interactive Data Language
   
   ; Routines in this script and their purpose:
   ; IDL Subtoutines in this file
   ;   
   ;-------------------------------------------------------------------------------------- 



pro mreadf,filename,word_start,bytes_per_word, $
           Number_Of_Words,Number_Of_Words_Read,Header_Buffer_Temp

    openr,ur,filename,/get_lun,ERROR=err
       if err ne 0 then begin
          print,!ERROR_STATE.MSG
       endif else begin
          Number_Of_Words_Read = Number_Of_Words*bytes_per_word
          ;Header_Buffer_Temp = bytarr(Number_Of_Words_Read)
          ;byte_start = word_start*bytes_per_word-1
          byte_start = word_start*bytes_per_word
          POINT_LUN,ur,byte_start
          if not eof(ur) then begin
         skip_lun,ur,/eof,transfer_count=byte_remain
         if byte_remain lt Number_Of_Words_Read then Number_Of_Words_Read=byte_remain
             Header_Buffer_Temp = bytarr(Number_Of_Words_Read)
         POINT_LUN,ur,byte_start
             readu,ur,Header_Buffer_Temp
          endif else begin
             print,'eof while reading the data"
          endelse
       endelse
    free_lun,ur

end


   	   
	   
	   
	   
