PRO WRITE_BINARY, FILE, DATA, APPEND=APPEND
if (n_elements(append) eq 0) then append = 0
openw, lun, file, /get_lun, append=append
writeu, lun, data
free_lun, lun
END


pro lonto360,lonn
;;; this subroutine is not included in the main program read_gac_n18.pro, so I wrote this
;;; this subroutine is to convert longtitude from -180,180 to 0 360

xxx = where(finite(lonn) and lonn lt 0., cxx)
if cxx gt 0 then lonn(xxx) = lonn(xxx)+360.
end

pro lonto180,lonn
;;; this subroutine is not included in the main program read_gac_n18.pro, so I wrote this
;;; this subroutine is to convert longtitude from 0 360 to -180,180

xxx = where(finite(lonn) and lonn gt 180., cxx)
if cxx gt 0 then lonn(xxx) = lonn(xxx)-360.
end

pro lonflip,lonn  ; added by Chia Moeller 3-2022 according to Mike Foster's suggestion
  xxx = where(finite(lonn) and lonn lt -180.0 and lonn ne -999., cxx)  ;need to flip
  if cxx gt 0 then lonn(xxx) = lonn(xxx)+360.
  xxx = where(finite(lonn) and lonn gt 180.0 and lonn ne -999., cxx)  ;need to flip
  if cxx gt 0 then lonn(xxx) = lonn(xxx)-360.
end

;---------------------------------prepare for VPP----------------------------------------
pro read_hdf_gac_noaa_forVPP, band_choice,filename,jday

  if (band_choice eq 'All_MBands') then begin
    read_vgac_noaa_allM, filename, viirs_data, lat, lon, hour_start, hour_end, szaa, satz, solaz, sataz, utc, $
                  year=year, day=day, second=second  
  endif else begin
    read_vgac_noaa_IandM, filename, viirs_data, lat, lon, hour_start, hour_end, szaa, satz, solaz, sataz, utc, $
                  year=year, day=day, second=second  
  endelse

; passing solaz and sataz out, and got rid of relaz. Chia Moeller 5-2022
    
fn=strmid(filename,strpos(filename,'/',/reverse_search)+1)
print, ' filename = ', fn
Sun_Earth_Distance = 1.0 - 0.016729*cos(0.9856*(jday-4.0)*!dtor)
sat_elev = 90. - satz   ;;; convert satellite zenith angle to satellite elevation angle, elevation angle = 90. - sensor_zenith_angle, confirmed
dims = size(lat,/dimension) ; modified by Chia Moeller
nx = dims(0)
utc_app = intarr(dims(0),dims(1)) 
;;convert hour fraction into utc
utc1 = fix(utc)       ;;; hour
utc2 = fix(((utc MOD 1)*60))   ;; minute
utc3 = fix(((((utc MOD 1)*60) MOD 1)*60)/10.)
utc_app1 = rotate((utc1*1000+utc2*10+utc3),1)

; check longitude sign
lonflip, lon
 
;take scan line time and make pixel times
for ic=0,nx-1 do utc_app(ic,*)=utc_app1

nlines = dims(1)
nout = lonarr(4)

nfields = 12
datat = fltarr(nfields,dims(0),dims(1))
datat(0,*,*) = lat
datat(1,*,*) = lon
datat(2:6,*,*)=viirs_data
datat(7,*,*) = szaa
datat(8,*,*) = sat_elev
;datat(9,*,*) = relaz removing relaz. composite will use zen2scan and calculate relaz
datat(9,*,*) = solaz        ; Solar Azimuth Angle  Chia Moeller 5-2022
datat(10,*,*) = sataz        ; Satllite Azimuth Angle  Chia Moeller 5-2022
datat(11,*,*) = utc_app

print, ' nlines = ', nlines

if nlines gt 0 then begin

; -------------------- extract data ------------------------
   northlim =  30.   ;; 30 degree north
   southlim = -30.   ;; 30 degree south
   southbound = -90. ;; 90 degree south
   northbound = 90.  ;; 90 degree north
   lat_count= 0. 

   writeflag=0
   northin=0
   southin=0
   wtog=0
   northfile = 0
   southfile = 0
   southstart = 0
   
   mid_index = nx/2  ;; middle of 801, or round(nx/2.) or floor/ceil(nx/2.). Modified by Chia Moeller 
   
   
   datat_NS = fltarr(4,nfields,nx,nlines)
   
   for ic=0,nlines-1 do begin
      if writeflag eq 0 then wtog = 0
      
      lat0 = datat(0,mid_index,ic)  ;;; latitude of subpoint of the satelliet 
    
      if lat0 gt northlim and lat0 le northbound then begin
         northin = 1
	 if wtog eq 0 then begin
	    if northfile eq 0 then begin
	       wtog = 1
	       nout(0) = 0
	       northfile = 1	
	       lat_count=0     	 
	    endif else begin
	       wtog = 1
	       nout(1) = 0
	       northfile = 2
	       lat_count=0 
	    endelse
	 endif   
	 
	 if northfile eq 1 then begin
	    datat_NS(0,*,*,nout(0)) = datat(*,*,ic)
	    nout(0) = nout(0)+1
	    writeflag = 1
	    lat_count=lat_count+1
	 endif
	 if northfile eq 2 then begin
	    datat_NS(1,*,*,nout(1)) = datat(*,*,ic)
	    nout(1) = nout(1)+1
	    writeflag = 1
	    lat_count=lat_count+1
	 endif	
      endif else begin
         northin = 0
      endelse 
	 
      
      if lat0 lt southlim and lat0 ge southbound then begin
         southin = 1
	  if wtog eq 0 or southstart eq 0 then begin
	  southstart = 1 
	    if southfile eq 0 then begin
	       wtog = 1
	       nout(2) = 0
	       southfile = 1
	       lat_count=0 
	    endif else begin
	       wtog = 1
	       nout(3) = 0
	       southfile = 2
	       lat_count=0 
	    endelse
	 endif
	 
	 if southfile eq 1 then begin
	    datat_NS(2,*,*,nout(2)) = datat(*,*,ic)
	    nout(2) = nout(2)+1
	    writeflag = 1
	    lat_count=lat_count+1	    
	 endif
	 if southfile eq 2 then begin
	    datat_NS(3,*,*,nout(3)) = datat(*,*,ic)
	    nout(3) = nout(3)+1
	    writeflag = 1	
	    lat_count=lat_count+1    	    
	 endif
	 
      endif else begin
         southin = 0
      endelse
      
      if northin eq 0 and southin eq 0 and lat0 le northbound and lat0 ge southbound and lat_count ge 10 then writeflag = 0  
      
      
   endfor   ; end for ic=0,nlines-1 do begin
   
   area_title = ['N1','N2','S1','S2']
; removing relaz. composite will use zen2scan and calculate relaz
   data_title = ['1','2','3','4','5','SZA','ELEV','AZIM','SAZA','TIME'] ; Chia Moeller 5-2022
   cam_per_scan = 10
   const1 = !pi/180.
   grid_sizes = [1805,1805,1605,1605]
   gpdfiles =['Na5.gpd','Na5.gpd','Sa5.gpd','Sa5.gpd']
   
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; reproject the data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   for ic=0,3 do begin  ; for loop on area_title
      if nout(ic) gt 0 then begin
         latt = reform(datat_NS(ic,0,*,0:nout(ic)-1))
         lonn = reform(datat_NS(ic,1,*,0:nout(ic)-1))
         dima = size(lonn,/dimension)
         xsize = dima(0)
         ysize = dima(1)/cam_per_scan
         latt = latt(*,0:ysize*cam_per_scan-1)  & lonn = lonn(*,0:ysize*cam_per_scan-1)  
         append = 0
	 openw,uw,'lat.'+area_title(ic)+'.dat',/get_lun
	 write_binary,'lat.dat',latt,append=append
         writeu,uw,latt
	 free_lun,uw
	 openw,uw,'lon.'+area_title(ic)+'.dat',/get_lun
	 write_binary,'lon.dat',lonn,append=append
         writeu,uw,lonn
	 free_lun,uw
   
   
         str1 = string(xsize)  & str2 = string(ysize)  & nnn = string(cam_per_scan)  & tag = 'viirs'
         stra = string(xsize,format='(i05)')  & strb = string(ysize,format='(i05)')  & ttt = string(cam_per_scan,format='(i02)')
         comm1 = 'll2cr  -f '+ string(xsize,format='(i5)')+string(ysize,format='(i5)')+'  '+ttt+' lat.dat lon.dat '+gpdfiles(ic)+' ' +tag
	 print,comm1
	 spawn,comm1
	 	 	 
	 grid_size = grid_sizes(ic)
	 if ic eq 0 or ic eq 1 then str_ns = ' 1805 1805 '  else str_ns =' 1605 1605 '
	 
	 field_count = 0
	    
         for id=0,nfields-3 do begin
	
	    temp = reform(datat_NS(ic,id+2,*,0:nout(ic)-1))               ; reflectance are set to -999. for solar zenith angle larger than 90
	    if id eq 0 or id eq 1 then begin
	       xxx = where(temp lt 0. or temp gt 1., cxx)                 ; check for quality of reflectant bands. Chia Moeller 2-2023
	       if cxx gt 0 then temp(xxx) = -999.
	       temp_szaa = reform(datat_NS(ic,7,*,0:nout(ic)-1))          ; solar zenith angle 
	       xxx = where(temp_szaa ge 90. and id le 1, cxx)
	       if cxx gt 0 then temp(xxx) = -999.
	       xxx = where(temp_szaa gt 0. and temp_szaa lt 90., cxx)     ; normalize the reflectance when solar zenith angle < 90 degree (night time)
	       ; VGAC reflectance is normalzied. Therefore, it needs to be un-normalized. Chia Moeller
	       if cxx gt 0 then temp(xxx) = temp(xxx)*(cos(temp_szaa(xxx)*const1)/Sun_Earth_Distance^2)
	    endif   
	    if id eq 2 or id eq 3 or id eq 4 then begin                   ; brightness temperature less than 0. are set to -999. for remap
	       ;xxx = where(temp lt 0., cxx)
	       xxx = where(temp lt 100. or temp gt 400., cxx)            ; check for quality of thermal bands. Chia Moeller 2-2023
	       if cxx gt 0 then temp(xxx) = -999.
	    endif   
	    
	    temp = temp(*,0:ysize*cam_per_scan-1)	    
	    write_binary,'temp.dat',temp,append=append

            name1 = tag+'_cols_'+stra+'_'+strb+'_00000_'+ttt+'.img'
            name2 = tag+'_rows_'+stra+'_'+strb+'_00000_'+ttt+'.img'
	    
            comm2 = 'fornav 1 -t f4 -f -999. -F -999. -D 5.0 -m '+str1+str2+nnn+' '+name1+' '+name2+' '+'temp.dat '+ str_ns +fn+'.'+area_title(ic)+'.'+data_title(id)+'a'
            print,comm2
            spawn,comm2
	    
	    
	    file_res = file_info(fn+'.'+area_title(ic)+'.'+data_title(id)+'a')
	    if file_res.exists eq 1 then begin	    
	       dtemp1 = fltarr(grid_size,grid_size)
	       dtemp2 = uintarr(grid_size,grid_size)
	       openr,ur,fn+'.'+area_title(ic)+'.'+data_title(id)+'a',/get_lun
	          readu,ur,dtemp1
		  
               if id ne nfields-3 then begin
;   abs is for relative azimuth angle (-180, 180) ; VGAC reflectance albedo is 0-1 NOT 0-100 like APP 4-2022 Chia Moeller
	        if id eq 0 or id eq 1 then dtemp2 = uint(abs(dtemp1)*1000.) else dtemp2 = uint(abs(dtemp1)*10.)
               endif else begin
		dtemp2 = uint(abs(dtemp1)*1.)
                print, ' for uint(abs(dtemp1)*1.) is ', data_title(id)
               endelse
	    
	       xxx = where(dtemp1 lt -200. , cxx)                ; acutally -999., 
	       if cxx gt 0 then dtemp2(xxx) = uint(0)            ; for relative azimuth angle, set to 0 too

	       if id eq 5 or id eq 6 or id eq 7 or id eq 8 then begin       ; make sure angles are positive number
                xxx=where(dtemp2 lt -200., cxx)
                if cxx gt 0 then dtemp2(xxx)=dtemp2(xxx)+3600
               endif
	    
	       ;   note, this is for consistence with composite_lst.pro 
; x86-64 is little endian. IDL composite process reads in big endian. Therefore, swaps is needed here.  Chia Moeller
               if (!version.arch ne 'ppc') then begin
		 dtemp2 = swap_endian(dtemp2)
	       endif
	    
	       openw,uw,fn+'.'+area_title(ic)+'.'+data_title(id),/get_lun
	          writeu,uw,dtemp2
	       free_lun,uw
	    
	       field_count = field_count+1
	    endif
	    
         endfor	 ; end for id=0,nfields-4 do begin
	 
      endif  ; end  if nout(ic) gt 0 then begin

   endfor    ; end ic-loop
   
endif   ; end if nlines gt 0 then begin

end

PRO read_vgac_noaa_allM, filename, viirs_data, lat, lon, hour_start, hour_end, szaa, satz, solaz, sataz, utc, $
                  year=year, day=day, second=second  
; passing solaz and sataz out, and got rid of relaz. Chia Moeller 5-2022
;some changed made for VGAC. Chia Moeller
; added time_coverage for output. Need to modify time from avhrr to viirs coverage
id=ncdf_open(filename,/NOWRITE)
NCDF_ATTGET, id, /GLOBAL, 'orbit_number', orb
NCDF_ATTGET, id, /GLOBAL, 'time_coverage_start', time_start
reads, strmid(time_start, 11, 2), tmp
hour_start = strmid(string(tmp,format='(f7.4)'),0,2)
NCDF_ATTGET, id, /GLOBAL, 'time_coverage_end', time_end
reads, strmid(time_end, 11, 2), tmp
hour_end = strmid(string(tmp,format='(f7.4)'),0,2)
check_id = NCDF_DIMID(id,'nscn')
NCDF_DIMINQ, id, check_id, dim_name, dim_size
nlines=dim_size

varid = NCDF_VARID(id, 'lat')
NCDF_VARGET, id, varid, lat

varid = NCDF_VARID(id, 'lon')
NCDF_VARGET, id, varid, lon

varid = NCDF_VARID(id, 'time')          ; changed for viirs
NCDF_VARGET, id, Varid, clocktm
varid = NCDF_VARID(id, 'proj_time0')
NCDF_VARGET, id, Varid, basetm
utc=((basetm MOD 1)*24)+clocktm         ; changed for viirs

varid = NCDF_VARID(id, 'vza')    ; Satellite zenith angle
NCDF_VARGET, id, varid, satz

varid = NCDF_VARID(id, 'sza')    ; Solar zenith angle
NCDF_VARGET, id, varid, szaa

varid = NCDF_VARID(id, 'azi')    ; Satellite azimuth angle
NCDF_VARGET, id, Varid, sataz

varid = NCDF_VARID(id, 'azn')    ; Solar azimuth angle
NCDF_VARGET, id, Varid, solaz

satz = float(satz)*0.5
szaa = float(szaa)*0.5
sataz = float(sataz)*0.5
solaz = float(solaz)*0.5  ; Chia Moeller 5-2022
relaz = solaz - sataz

varid = NCDF_VARID(id, 'M05')
NCDF_VARGET, id, Varid, ch1_m05_dat
ch1_dat=float(ch1_m05_dat)*0.0001

varid = NCDF_VARID(id, 'M07')
NCDF_VARGET, id, Varid, ch2_m07_dat
ch2_dat=float(ch2_m07_dat)*0.0001

varid = NCDF_VARID(id, 'M12')
NCDF_VARGET, id, Varid, ch3_m12_dat
varid = NCDF_VARID(id, 'M12_LUT')
NCDF_VARGET, id, Varid, ch3b_m12lut_dat
ch3b_dat=ch3b_m12lut_dat(long(float(ch3_m12_dat)))

varid = NCDF_VARID(id, 'M15')
NCDF_VARGET, id, Varid, ch4_m15_dat
varid = NCDF_VARID(id, 'M15_LUT')
NCDF_VARGET, id, Varid, ch4_m15lut_dat
ch4_dat=ch4_m15lut_dat(long(float(ch4_m15_dat)))

varid = NCDF_VARID(id, 'M16')
NCDF_VARGET, id, Varid, ch5_m16_dat
varid = NCDF_VARID(id, 'M16_LUT')
NCDF_VARGET, id, Varid, ch5_m16lut_dat
ch5_dat=ch5_m16lut_dat(long(float(ch5_m16_dat)))

check_id = NCDF_DIMID(id,'npix')
NCDF_DIMINQ, id, check_id, dim_name, dim_size
nx=dim_size
ny=nlines
nchan=5
viirs_data = make_array(nchan,nx,ny, /float)
viirs_data[0, *, *]=ch1_dat
viirs_data[1, *, *]=ch2_dat
viirs_data[2, *, *]=ch3b_dat
viirs_data[3, *, *]=ch4_dat
viirs_data[4, *, *]=ch5_dat

end

PRO read_vgac_noaa_IandM, filename, viirs_data, lat, lon, hour_start, hour_end, szaa, satz, solaz, sataz, utc, $
                  year=year, day=day, second=second
; passing solaz and sataz out, and got rid of relaz. Chia Moeller 5-2022
;some changed made for VGAC. Chia Moeller
; added time_coverage for output. Need to modify time from avhrr to viirs coverage
id=ncdf_open(filename,/NOWRITE)
NCDF_ATTGET, id, /GLOBAL, 'orbit_number', orb
NCDF_ATTGET, id, /GLOBAL, 'time_coverage_start', time_start
reads, strmid(time_start, 11, 2), tmp
hour_start = strmid(string(tmp,format='(f7.4)'),0,2)
NCDF_ATTGET, id, /GLOBAL, 'time_coverage_end', time_end
reads, strmid(time_end, 11, 2), tmp
hour_end = strmid(string(tmp,format='(f7.4)'),0,2)
check_id = NCDF_DIMID(id,'nscn')
NCDF_DIMINQ, id, check_id, dim_name, dim_size
nlines=dim_size

varid = NCDF_VARID(id, 'lat')
NCDF_VARGET, id, varid, lat

varid = NCDF_VARID(id, 'lon')
NCDF_VARGET, id, varid, lon

varid = NCDF_VARID(id, 'time')          ; changed for viirs
NCDF_VARGET, id, Varid, clocktm
varid = NCDF_VARID(id, 'proj_time0')
NCDF_VARGET, id, Varid, basetm
utc=((basetm MOD 1)*24)+clocktm         ; changed for viirs

varid = NCDF_VARID(id, 'vza')    ; Satellite zenith angle
NCDF_VARGET, id, varid, satz

varid = NCDF_VARID(id, 'sza')    ; Solar zenith angle
NCDF_VARGET, id, varid, szaa

varid = NCDF_VARID(id, 'azi')    ; Satellite azimuth angle
NCDF_VARGET, id, Varid, sataz

varid = NCDF_VARID(id, 'azn')    ; Solar azimuth angle
NCDF_VARGET, id, Varid, solaz

satz = float(satz)*0.5
szaa = float(szaa)*0.5
sataz = float(sataz)*0.5
solaz = float(solaz)*0.5  ; Chia Moeller 5-2022
relaz = solaz - sataz

varid = NCDF_VARID(id, 'i01_avg')
NCDF_VARGET, id, Varid, ch1_i01_dat
ch1_dat=float(ch1_i01_dat)*0.001

varid = NCDF_VARID(id, 'i02_avg')
NCDF_VARGET, id, Varid, ch2_i02_dat
ch2_dat=float(ch2_i02_dat)*0.001

varid = NCDF_VARID(id, 'i04_avg')
NCDF_VARGET, id, Varid, ch3_i04_dat
varid = NCDF_VARID(id, 'i04_LUT')
NCDF_VARGET, id, Varid, ch3b_i04lut_dat
ch3b_dat=ch3b_i04lut_dat(long(float(ch3_i04_dat)))

varid = NCDF_VARID(id, 'M15')
NCDF_VARGET, id, Varid, ch4_m15_dat
varid = NCDF_VARID(id, 'M15_LUT')
NCDF_VARGET, id, Varid, ch4_m15lut_dat
ch4_dat=ch4_m15lut_dat(long(float(ch4_m15_dat)))

varid = NCDF_VARID(id, 'M16')
NCDF_VARGET, id, Varid, ch5_m16_dat
varid = NCDF_VARID(id, 'M16_LUT')
NCDF_VARGET, id, Varid, ch5_m16lut_dat
ch5_dat=ch5_m16lut_dat(long(float(ch5_m16_dat)))

check_id = NCDF_DIMID(id,'npix')
NCDF_DIMINQ, id, check_id, dim_name, dim_size
nx=dim_size
ny=nlines
nchan=5
viirs_data = make_array(nchan,nx,ny, /float)
viirs_data[0, *, *]=ch1_dat
viirs_data[1, *, *]=ch2_dat
viirs_data[2, *, *]=ch3b_dat
viirs_data[3, *, *]=ch4_dat
viirs_data[4, *, *]=ch5_dat

end

